-----------------------------------------------------------------------------------------------
-- Client Lua Script for CraftDismount
-- Copyright (c) Ryirs. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Apollo"
require "CraftingLib"
require "GameLib"
 
-----------------------------------------------------------------------------------------------
-- CraftDismount Module Definition
-----------------------------------------------------------------------------------------------
local CraftDismount = {} 
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function CraftDismount:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
    return o
end

function CraftDismount:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {}
	Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end

-----------------------------------------------------------------------------------------------
-- CraftDismount Functions
-----------------------------------------------------------------------------------------------

-- Custom OnCraftBtnClicked Override function
function CraftDismount:CompleteCraft(tMicrochips, tThresholds)
	
	-- check/dismount
	GameLib:Disembark()
	
	-- Run default craft function
	CraftDismount.carbineFunction(tMicrochips, tThresholds)
end


-----------------------------------------------------------------------------------------------
-- CraftDismount OnLoad
-----------------------------------------------------------------------------------------------
function CraftDismount:OnLoad()
	-- store default carbine function
	CraftDismount.carbineFunction = CraftingLib.CompleteCraft
	
	-- override default carbine function
	CraftingLib.CompleteCraft = CraftDismount.CompleteCraft
end

-----------------------------------------------------------------------------------------------
-- CraftDismount Instance
-----------------------------------------------------------------------------------------------
local CraftDismountInst = CraftDismount:new()
CraftDismountInst:Init()

